#!/usr/bin/env ruby

# print current settings
#   $ stty -g < /dev/ttyUSB2

$config = Hash.new
$config['tty']  = '/dev/ttyUSB2'
$config['stty'] = '1:0:800008bd:0:3:1c:7f:15:4:5:1:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0'	#  9600bps
#config['stty'] = '1:0:800018b1:0:3:1c:7f:15:4:5:1:0:11:13:1a:0:12:f:17:16:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0'	# 57600bps

system("stty #{$config['stty']} < #{$config['tty']}")

fh = open('serialDebug.dump', 'w')

open($config['tty'], 'w+') {|target|
	p = 0; w = 16; ww = w * 16; cbuf = ''
	loop {
#		(p % ww == 0) and print "\n#Address    +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F 'Character\n"
		(p % w  == 0) and print '#%08x =' % p
		print ' %02X' % (c = target.getc); $stdout.flush
		fh.putc(c)
		cbuf += (c < 0 ? ' ' : sprintf('%c', (c > 0x1f and c < 0x7f) ? c : ?.))
		if((p += 1) % w == 0)
			print " '%s\n" % cbuf; cbuf = ''
		end
	}
}

__END__

